"""Implementation of statechart statechart.
Generated by YAKINDU Statechart Tools code generator.
"""

import queue
import sys, os
sys.path.insert(0, os.path.abspath(os.path.join(os.path.dirname(__file__), '../src')))
from yakindu.rx import Observable

class Statechart:
	"""Implementation of the state machine Statechart.
	"""

	class State:
		""" State Enum
		"""
		(
			main_region_traffic_light,
			main_region_traffic_light_r1interrupted,
			main_region_traffic_light_r1interrupted_region0yellow,
			main_region_traffic_light_r1interrupted_region0black,
			main_region_traffic_light_r1normal_operation,
			main_region_traffic_light_r1normal_operation_region0green,
			main_region_traffic_light_r1normal_operation_region0yellow,
			main_region_traffic_light_r1normal_operation_region0red,
			main_region_traffic_light_r2timer,
			main_region_traffic_light_r2timer_region0off,
			main_region_traffic_light_r2timer_region0on,
			main_region_off,
			null_state
		) = range(13)
	
	
	def __init__(self):
		""" Declares all necessary variables including list of states, histories etc. 
		"""
		
		self.display_red = None
		self.display_red_observable = Observable()
		self.display_yellow = None
		self.display_yellow_observable = Observable()
		self.display_green = None
		self.display_green_observable = Observable()
		self.display_none = None
		self.display_none_observable = Observable()
		self.display_red_and_yellow = None
		self.display_red_and_yellow_observable = Observable()
		self.interrupt = None
		self.toggle_on_off = None
		self.set_timer_value = None
		self.set_timer_value_value = None
		self.set_timer_value_observable = Observable()
		
		self.__internal_event_queue = queue.Queue()
		self.in_event_queue = queue.Queue()
		self.__remaining_time = None
		self.timer_on = None
		self.timer_off = None
		
		# enumeration of all states:
		self.__State = Statechart.State
		self.__state_conf_vector_changed = None
		self.__state_vector = [None] * 2
		for __state_index in range(2):
			self.__state_vector[__state_index] = self.State.null_state
		
		# for timed statechart:
		self.timer_service = None
		self.__time_events = [None] * 6
		
		# history vector:
		self.__history_vector = [None] * 3
		for __history_index in range(3):
			self.__history_vector[__history_index] = self.State.null_state
		
		# initializations:
		self.__remaining_time = 0.0
		self.__is_executing = False
		self.__state_conf_vector_position = None
	
	def is_active(self):
		"""Checks if the state machine is active.
		"""
		return self.__state_vector[0] is not self.__State.null_state or self.__state_vector[1] is not self.__State.null_state
	
	def is_final(self):
		"""Checks if the statemachine is final.
		Always returns 'false' since this state machine can never become final.
		"""
		return False
			
	def is_state_active(self, state):
		"""Checks if the state is currently active.
		"""
		s = state
		if s == self.__State.main_region_traffic_light:
			return (self.__state_vector[0] >= self.__State.main_region_traffic_light)\
				and (self.__state_vector[0] <= self.__State.main_region_traffic_light_r2timer_region0on)
		if s == self.__State.main_region_traffic_light_r1interrupted:
			return (self.__state_vector[0] >= self.__State.main_region_traffic_light_r1interrupted)\
				and (self.__state_vector[0] <= self.__State.main_region_traffic_light_r1interrupted_region0black)
		if s == self.__State.main_region_traffic_light_r1interrupted_region0yellow:
			return self.__state_vector[0] == self.__State.main_region_traffic_light_r1interrupted_region0yellow
		if s == self.__State.main_region_traffic_light_r1interrupted_region0black:
			return self.__state_vector[0] == self.__State.main_region_traffic_light_r1interrupted_region0black
		if s == self.__State.main_region_traffic_light_r1normal_operation:
			return (self.__state_vector[0] >= self.__State.main_region_traffic_light_r1normal_operation)\
				and (self.__state_vector[0] <= self.__State.main_region_traffic_light_r1normal_operation_region0red)
		if s == self.__State.main_region_traffic_light_r1normal_operation_region0green:
			return self.__state_vector[0] == self.__State.main_region_traffic_light_r1normal_operation_region0green
		if s == self.__State.main_region_traffic_light_r1normal_operation_region0yellow:
			return self.__state_vector[0] == self.__State.main_region_traffic_light_r1normal_operation_region0yellow
		if s == self.__State.main_region_traffic_light_r1normal_operation_region0red:
			return self.__state_vector[0] == self.__State.main_region_traffic_light_r1normal_operation_region0red
		if s == self.__State.main_region_traffic_light_r2timer:
			return (self.__state_vector[1] >= self.__State.main_region_traffic_light_r2timer)\
				and (self.__state_vector[1] <= self.__State.main_region_traffic_light_r2timer_region0on)
		if s == self.__State.main_region_traffic_light_r2timer_region0off:
			return self.__state_vector[1] == self.__State.main_region_traffic_light_r2timer_region0off
		if s == self.__State.main_region_traffic_light_r2timer_region0on:
			return self.__state_vector[1] == self.__State.main_region_traffic_light_r2timer_region0on
		if s == self.__State.main_region_off:
			return self.__state_vector[0] == self.__State.main_region_off
		return False
		
	def time_elapsed(self, event_id):
		"""Add time events to in event queue
		"""
		if event_id in range(6):
			self.in_event_queue.put(lambda: self.raise_time_event(event_id))
			self.run_cycle()
	
	def raise_time_event(self, event_id):
		"""Raise timed events using the event_id.
		"""
		self.__time_events[event_id] = True
	
	def __execute_queued_event(self, func):
		func()
	
	def __get_next_event(self):
		if not self.__internal_event_queue.empty():
			return self.__internal_event_queue.get()
		if not self.in_event_queue.empty():
			return self.in_event_queue.get()
		return None
	
	
	def raise_timer_on(self):
		"""Raise method for event timer_on.
		"""
		self.__internal_event_queue.put(self.__raise_timer_on_call)
	
	def __raise_timer_on_call(self):
		"""Raise callback for event timer_on.
		"""
		self.timer_on = True
	
	def raise_timer_off(self):
		"""Raise method for event timer_off.
		"""
		self.__internal_event_queue.put(self.__raise_timer_off_call)
	
	def __raise_timer_off_call(self):
		"""Raise callback for event timer_off.
		"""
		self.timer_off = True
	
	def raise_interrupt(self):
		"""Raise method for event interrupt.
		"""
		self.in_event_queue.put(self.__raise_interrupt_call)
		self.run_cycle()
	
	def __raise_interrupt_call(self):
		"""Raise callback for event interrupt.
		"""
		self.interrupt = True
	
	def raise_toggle_on_off(self):
		"""Raise method for event toggle_on_off.
		"""
		self.in_event_queue.put(self.__raise_toggle_on_off_call)
		self.run_cycle()
	
	def __raise_toggle_on_off_call(self):
		"""Raise callback for event toggle_on_off.
		"""
		self.toggle_on_off = True
	
	def __entry_action_main_region_traffic_light_r1_interrupted__region0_yellow(self):
		"""Entry action for state 'Yellow'..
		"""
		self.timer_service.set_timer(self, 0, 500, False)
		self.display_yellow_observable.next()
		
	def __entry_action_main_region_traffic_light_r1_interrupted__region0_black(self):
		"""Entry action for state 'Black'..
		"""
		self.timer_service.set_timer(self, 1, 500, False)
		self.display_none_observable.next()
		
	def __entry_action_main_region_traffic_light_r1_normal_operation__region0_green(self):
		"""Entry action for state 'Green'..
		"""
		self.timer_service.set_timer(self, 2, 5500, False)
		self.display_green_observable.next()
		self.raise_timer_on()
		self.__remaining_time = 5.5
		
	def __entry_action_main_region_traffic_light_r1_normal_operation__region0_yellow(self):
		"""Entry action for state 'Yellow'..
		"""
		self.timer_service.set_timer(self, 3, 500, False)
		self.display_yellow_observable.next()
		
	def __entry_action_main_region_traffic_light_r1_normal_operation__region0_red(self):
		"""Entry action for state 'Red'..
		"""
		self.timer_service.set_timer(self, 4, (6 * 1000), False)
		self.display_red_observable.next()
		self.raise_timer_on()
		self.__remaining_time = 6
		
	def __entry_action_main_region_traffic_light_r2_timer__region0_on(self):
		"""Entry action for state 'On'..
		"""
		self.timer_service.set_timer(self, 5, (1 * 1000), False)
		self.set_timer_value_observable.next(self.__remaining_time)
		
	def __entry_action_main_region_off(self):
		"""Entry action for state 'Off'..
		"""
		self.display_none_observable.next()
		
	def __exit_action_main_region_traffic_light_r1_interrupted__region0_yellow(self):
		"""Exit action for state 'Yellow'..
		"""
		self.timer_service.unset_timer(self, 0)
		
	def __exit_action_main_region_traffic_light_r1_interrupted__region0_black(self):
		"""Exit action for state 'Black'..
		"""
		self.timer_service.unset_timer(self, 1)
		
	def __exit_action_main_region_traffic_light_r1_normal_operation__region0_green(self):
		"""Exit action for state 'Green'..
		"""
		self.timer_service.unset_timer(self, 2)
		self.raise_timer_off()
		
	def __exit_action_main_region_traffic_light_r1_normal_operation__region0_yellow(self):
		"""Exit action for state 'Yellow'..
		"""
		self.timer_service.unset_timer(self, 3)
		
	def __exit_action_main_region_traffic_light_r1_normal_operation__region0_red(self):
		"""Exit action for state 'Red'..
		"""
		self.timer_service.unset_timer(self, 4)
		self.raise_timer_off()
		
	def __exit_action_main_region_traffic_light_r2_timer__region0_on(self):
		"""Exit action for state 'On'..
		"""
		self.timer_service.unset_timer(self, 5)
		self.set_timer_value_observable.next(-1)
		
	def __enter_sequence_main_region_traffic_light_default(self):
		"""'default' enter sequence for state TrafficLight.
		"""
		self.__enter_sequence_main_region_traffic_light_r1_default()
		self.__enter_sequence_main_region_traffic_light_r2_default()
		
	def __enter_sequence_main_region_traffic_light_r1_interrupted_default(self):
		"""'default' enter sequence for state Interrupted.
		"""
		self.__enter_sequence_main_region_traffic_light_r1_interrupted__region0_default()
		self.__history_vector[0] = self.__state_vector[0]
		
	def __enter_sequence_main_region_traffic_light_r1_interrupted__region0_yellow_default(self):
		"""'default' enter sequence for state Yellow.
		"""
		self.__entry_action_main_region_traffic_light_r1_interrupted__region0_yellow()
		self.__state_vector[0] = self.State.main_region_traffic_light_r1interrupted_region0yellow
		self.__state_conf_vector_position = 0
		self.__state_conf_vector_changed = True
		self.__history_vector[1] = self.__state_vector[0]
		
	def __enter_sequence_main_region_traffic_light_r1_interrupted__region0_black_default(self):
		"""'default' enter sequence for state Black.
		"""
		self.__entry_action_main_region_traffic_light_r1_interrupted__region0_black()
		self.__state_vector[0] = self.State.main_region_traffic_light_r1interrupted_region0black
		self.__state_conf_vector_position = 0
		self.__state_conf_vector_changed = True
		self.__history_vector[1] = self.__state_vector[0]
		
	def __enter_sequence_main_region_traffic_light_r1_normal_operation_default(self):
		"""'default' enter sequence for state NormalOperation.
		"""
		self.__enter_sequence_main_region_traffic_light_r1_normal_operation__region0_default()
		self.__history_vector[0] = self.__state_vector[0]
		
	def __enter_sequence_main_region_traffic_light_r1_normal_operation__region0_green_default(self):
		"""'default' enter sequence for state Green.
		"""
		self.__entry_action_main_region_traffic_light_r1_normal_operation__region0_green()
		self.__state_vector[0] = self.State.main_region_traffic_light_r1normal_operation_region0green
		self.__state_conf_vector_position = 0
		self.__state_conf_vector_changed = True
		self.__history_vector[2] = self.__state_vector[0]
		
	def __enter_sequence_main_region_traffic_light_r1_normal_operation__region0_yellow_default(self):
		"""'default' enter sequence for state Yellow.
		"""
		self.__entry_action_main_region_traffic_light_r1_normal_operation__region0_yellow()
		self.__state_vector[0] = self.State.main_region_traffic_light_r1normal_operation_region0yellow
		self.__state_conf_vector_position = 0
		self.__state_conf_vector_changed = True
		self.__history_vector[2] = self.__state_vector[0]
		
	def __enter_sequence_main_region_traffic_light_r1_normal_operation__region0_red_default(self):
		"""'default' enter sequence for state Red.
		"""
		self.__entry_action_main_region_traffic_light_r1_normal_operation__region0_red()
		self.__state_vector[0] = self.State.main_region_traffic_light_r1normal_operation_region0red
		self.__state_conf_vector_position = 0
		self.__state_conf_vector_changed = True
		self.__history_vector[2] = self.__state_vector[0]
		
	def __enter_sequence_main_region_traffic_light_r2_timer_default(self):
		"""'default' enter sequence for state Timer.
		"""
		self.__enter_sequence_main_region_traffic_light_r2_timer__region0_default()
		
	def __enter_sequence_main_region_traffic_light_r2_timer__region0_off_default(self):
		"""'default' enter sequence for state Off.
		"""
		self.__state_vector[1] = self.State.main_region_traffic_light_r2timer_region0off
		self.__state_conf_vector_position = 1
		self.__state_conf_vector_changed = True
		
	def __enter_sequence_main_region_traffic_light_r2_timer__region0_on_default(self):
		"""'default' enter sequence for state On.
		"""
		self.__entry_action_main_region_traffic_light_r2_timer__region0_on()
		self.__state_vector[1] = self.State.main_region_traffic_light_r2timer_region0on
		self.__state_conf_vector_position = 1
		self.__state_conf_vector_changed = True
		
	def __enter_sequence_main_region_off_default(self):
		"""'default' enter sequence for state Off.
		"""
		self.__entry_action_main_region_off()
		self.__state_vector[0] = self.State.main_region_off
		self.__state_conf_vector_position = 0
		self.__state_conf_vector_changed = True
		
	def __enter_sequence_main_region_default(self):
		"""'default' enter sequence for region main region.
		"""
		self.__react_main_region__entry_default()
		
	def __enter_sequence_main_region_traffic_light_r1_default(self):
		"""'default' enter sequence for region r1.
		"""
		self.__react_main_region_traffic_light_r1__entry_default()
		
	def __deep_enter_sequence_main_region_traffic_light_r1(self):
		"""deep enterSequence with history in child r1.
		"""
		state = self.__history_vector[0]
		if state == self.State.main_region_traffic_light_r1interrupted_region0yellow:
			self.__deep_enter_sequence_main_region_traffic_light_r1_interrupted__region0()
		elif state == self.State.main_region_traffic_light_r1interrupted_region0black:
			self.__deep_enter_sequence_main_region_traffic_light_r1_interrupted__region0()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0green:
			self.__deep_enter_sequence_main_region_traffic_light_r1_normal_operation__region0()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0yellow:
			self.__deep_enter_sequence_main_region_traffic_light_r1_normal_operation__region0()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0red:
			self.__deep_enter_sequence_main_region_traffic_light_r1_normal_operation__region0()
		
	def __enter_sequence_main_region_traffic_light_r1_interrupted__region0_default(self):
		"""'default' enter sequence for region null.
		"""
		self.__react_main_region_traffic_light_r1_interrupted__region0__entry_default()
		
	def __deep_enter_sequence_main_region_traffic_light_r1_interrupted__region0(self):
		"""deep enterSequence with history in child null.
		"""
		state = self.__history_vector[1]
		if state == self.State.main_region_traffic_light_r1interrupted_region0yellow:
			self.__enter_sequence_main_region_traffic_light_r1_interrupted__region0_yellow_default()
		elif state == self.State.main_region_traffic_light_r1interrupted_region0black:
			self.__enter_sequence_main_region_traffic_light_r1_interrupted__region0_black_default()
		
	def __enter_sequence_main_region_traffic_light_r1_normal_operation__region0_default(self):
		"""'default' enter sequence for region null.
		"""
		self.__react_main_region_traffic_light_r1_normal_operation__region0__entry_default()
		
	def __deep_enter_sequence_main_region_traffic_light_r1_normal_operation__region0(self):
		"""deep enterSequence with history in child null.
		"""
		state = self.__history_vector[2]
		if state == self.State.main_region_traffic_light_r1normal_operation_region0green:
			self.__enter_sequence_main_region_traffic_light_r1_normal_operation__region0_green_default()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0yellow:
			self.__enter_sequence_main_region_traffic_light_r1_normal_operation__region0_yellow_default()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0red:
			self.__enter_sequence_main_region_traffic_light_r1_normal_operation__region0_red_default()
		
	def __shallow_enter_sequence_main_region_traffic_light_r1_normal_operation__region0(self):
		"""shallow enterSequence with history in child null.
		"""
		state = self.__history_vector[2]
		if state == self.State.main_region_traffic_light_r1normal_operation_region0green:
			self.__enter_sequence_main_region_traffic_light_r1_normal_operation__region0_green_default()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0yellow:
			self.__enter_sequence_main_region_traffic_light_r1_normal_operation__region0_yellow_default()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0red:
			self.__enter_sequence_main_region_traffic_light_r1_normal_operation__region0_red_default()
		
	def __enter_sequence_main_region_traffic_light_r2_default(self):
		"""'default' enter sequence for region r2.
		"""
		self.__react_main_region_traffic_light_r2__entry_default()
		
	def __enter_sequence_main_region_traffic_light_r2_timer__region0_default(self):
		"""'default' enter sequence for region null.
		"""
		self.__react_main_region_traffic_light_r2_timer__region0__entry_default()
		
	def __exit_sequence_main_region_traffic_light(self):
		"""Default exit sequence for state TrafficLight.
		"""
		self.__exit_sequence_main_region_traffic_light_r1()
		self.__exit_sequence_main_region_traffic_light_r2()
		
	def __exit_sequence_main_region_traffic_light_r1_interrupted(self):
		"""Default exit sequence for state Interrupted.
		"""
		self.__exit_sequence_main_region_traffic_light_r1_interrupted__region0()
		
	def __exit_sequence_main_region_traffic_light_r1_interrupted__region0_yellow(self):
		"""Default exit sequence for state Yellow.
		"""
		self.__state_vector[0] = self.State.null_state
		self.__state_conf_vector_position = 0
		self.__exit_action_main_region_traffic_light_r1_interrupted__region0_yellow()
		
	def __exit_sequence_main_region_traffic_light_r1_interrupted__region0_black(self):
		"""Default exit sequence for state Black.
		"""
		self.__state_vector[0] = self.State.null_state
		self.__state_conf_vector_position = 0
		self.__exit_action_main_region_traffic_light_r1_interrupted__region0_black()
		
	def __exit_sequence_main_region_traffic_light_r1_normal_operation(self):
		"""Default exit sequence for state NormalOperation.
		"""
		self.__exit_sequence_main_region_traffic_light_r1_normal_operation__region0()
		
	def __exit_sequence_main_region_traffic_light_r1_normal_operation__region0_green(self):
		"""Default exit sequence for state Green.
		"""
		self.__state_vector[0] = self.State.null_state
		self.__state_conf_vector_position = 0
		self.__exit_action_main_region_traffic_light_r1_normal_operation__region0_green()
		
	def __exit_sequence_main_region_traffic_light_r1_normal_operation__region0_yellow(self):
		"""Default exit sequence for state Yellow.
		"""
		self.__state_vector[0] = self.State.null_state
		self.__state_conf_vector_position = 0
		self.__exit_action_main_region_traffic_light_r1_normal_operation__region0_yellow()
		
	def __exit_sequence_main_region_traffic_light_r1_normal_operation__region0_red(self):
		"""Default exit sequence for state Red.
		"""
		self.__state_vector[0] = self.State.null_state
		self.__state_conf_vector_position = 0
		self.__exit_action_main_region_traffic_light_r1_normal_operation__region0_red()
		
	def __exit_sequence_main_region_traffic_light_r2_timer__region0_off(self):
		"""Default exit sequence for state Off.
		"""
		self.__state_vector[1] = self.State.null_state
		self.__state_conf_vector_position = 1
		
	def __exit_sequence_main_region_traffic_light_r2_timer__region0_on(self):
		"""Default exit sequence for state On.
		"""
		self.__state_vector[1] = self.State.null_state
		self.__state_conf_vector_position = 1
		self.__exit_action_main_region_traffic_light_r2_timer__region0_on()
		
	def __exit_sequence_main_region_off(self):
		"""Default exit sequence for state Off.
		"""
		self.__state_vector[0] = self.State.null_state
		self.__state_conf_vector_position = 0
		
	def __exit_sequence_main_region(self):
		"""Default exit sequence for region main region.
		"""
		state = self.__state_vector[0]
		if state == self.State.main_region_traffic_light_r1interrupted_region0yellow:
			self.__exit_sequence_main_region_traffic_light_r1_interrupted__region0_yellow()
		elif state == self.State.main_region_traffic_light_r1interrupted_region0black:
			self.__exit_sequence_main_region_traffic_light_r1_interrupted__region0_black()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0green:
			self.__exit_sequence_main_region_traffic_light_r1_normal_operation__region0_green()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0yellow:
			self.__exit_sequence_main_region_traffic_light_r1_normal_operation__region0_yellow()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0red:
			self.__exit_sequence_main_region_traffic_light_r1_normal_operation__region0_red()
		elif state == self.State.main_region_off:
			self.__exit_sequence_main_region_off()
		state = self.__state_vector[1]
		if state == self.State.main_region_traffic_light_r2timer_region0off:
			self.__exit_sequence_main_region_traffic_light_r2_timer__region0_off()
		elif state == self.State.main_region_traffic_light_r2timer_region0on:
			self.__exit_sequence_main_region_traffic_light_r2_timer__region0_on()
		
	def __exit_sequence_main_region_traffic_light_r1(self):
		"""Default exit sequence for region r1.
		"""
		state = self.__state_vector[0]
		if state == self.State.main_region_traffic_light_r1interrupted_region0yellow:
			self.__exit_sequence_main_region_traffic_light_r1_interrupted__region0_yellow()
		elif state == self.State.main_region_traffic_light_r1interrupted_region0black:
			self.__exit_sequence_main_region_traffic_light_r1_interrupted__region0_black()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0green:
			self.__exit_sequence_main_region_traffic_light_r1_normal_operation__region0_green()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0yellow:
			self.__exit_sequence_main_region_traffic_light_r1_normal_operation__region0_yellow()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0red:
			self.__exit_sequence_main_region_traffic_light_r1_normal_operation__region0_red()
		
	def __exit_sequence_main_region_traffic_light_r1_interrupted__region0(self):
		"""Default exit sequence for region null.
		"""
		state = self.__state_vector[0]
		if state == self.State.main_region_traffic_light_r1interrupted_region0yellow:
			self.__exit_sequence_main_region_traffic_light_r1_interrupted__region0_yellow()
		elif state == self.State.main_region_traffic_light_r1interrupted_region0black:
			self.__exit_sequence_main_region_traffic_light_r1_interrupted__region0_black()
		
	def __exit_sequence_main_region_traffic_light_r1_normal_operation__region0(self):
		"""Default exit sequence for region null.
		"""
		state = self.__state_vector[0]
		if state == self.State.main_region_traffic_light_r1normal_operation_region0green:
			self.__exit_sequence_main_region_traffic_light_r1_normal_operation__region0_green()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0yellow:
			self.__exit_sequence_main_region_traffic_light_r1_normal_operation__region0_yellow()
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0red:
			self.__exit_sequence_main_region_traffic_light_r1_normal_operation__region0_red()
		
	def __exit_sequence_main_region_traffic_light_r2(self):
		"""Default exit sequence for region r2.
		"""
		state = self.__state_vector[1]
		if state == self.State.main_region_traffic_light_r2timer_region0off:
			self.__exit_sequence_main_region_traffic_light_r2_timer__region0_off()
		elif state == self.State.main_region_traffic_light_r2timer_region0on:
			self.__exit_sequence_main_region_traffic_light_r2_timer__region0_on()
		
	def __react_main_region_traffic_light_r1_interrupted__region0__entry_default(self):
		"""Default react sequence for initial entry .
		"""
		self.__enter_sequence_main_region_traffic_light_r1_interrupted__region0_yellow_default()
		
	def __react_main_region_traffic_light_r1_normal_operation__region0__entry_default(self):
		"""Default react sequence for initial entry .
		"""
		self.__enter_sequence_main_region_traffic_light_r1_normal_operation__region0_red_default()
		
	def __react_main_region_traffic_light_r1_normal_operation__region0_h(self):
		"""Default react sequence for shallow history entry h.
		"""
		#Enter the region with shallow history
		if self.__history_vector[2] is not self.State.null_state:
			self.__shallow_enter_sequence_main_region_traffic_light_r1_normal_operation__region0()
		else:
			self.__enter_sequence_main_region_traffic_light_r1_normal_operation__region0_red_default()
		
	def __react_main_region_traffic_light_r1__entry_default(self):
		"""Default react sequence for initial entry .
		"""
		self.__enter_sequence_main_region_traffic_light_r1_normal_operation_default()
		
	def __react_main_region_traffic_light_r1_h(self):
		"""Default react sequence for deep history entry h.
		"""
		#Enter the region with deep history
		if self.__history_vector[0] is not self.State.null_state:
			self.__deep_enter_sequence_main_region_traffic_light_r1()
		else:
			self.__enter_sequence_main_region_traffic_light_r1_normal_operation_default()
		
	def __react_main_region_traffic_light_r2_timer__region0__entry_default(self):
		"""Default react sequence for initial entry .
		"""
		self.__enter_sequence_main_region_traffic_light_r2_timer__region0_on_default()
		
	def __react_main_region_traffic_light_r2__entry_default(self):
		"""Default react sequence for initial entry .
		"""
		self.__enter_sequence_main_region_traffic_light_r2_timer_default()
		
	def __react_main_region__entry_default(self):
		"""Default react sequence for initial entry .
		"""
		self.__enter_sequence_main_region_traffic_light_default()
		
	def __react(self, transitioned_before):
		"""Implementation of __react function.
		"""
		return transitioned_before
	
	
	def __main_region_traffic_light_react(self, transitioned_before):
		"""Implementation of __main_region_traffic_light_react function.
		"""
		transitioned_after = transitioned_before
		if transitioned_after < 0:
			if (self.toggle_on_off) and (not self.is_state_active(self.State.main_region_traffic_light_r1interrupted)):
				self.__exit_sequence_main_region_traffic_light()
				self.__enter_sequence_main_region_off_default()
				self.__react(0)
				transitioned_after = 1
		#If no transition was taken then execute local reactions
		if transitioned_after == transitioned_before:
			transitioned_after = self.__react(transitioned_before)
		return transitioned_after
	
	
	def __main_region_traffic_light_r1_interrupted_react(self, transitioned_before):
		"""Implementation of __main_region_traffic_light_r1_interrupted_react function.
		"""
		transitioned_after = transitioned_before
		if transitioned_after < 0:
			if self.interrupt:
				self.__exit_sequence_main_region_traffic_light_r1_interrupted()
				self.__react_main_region_traffic_light_r1_normal_operation__region0_h()
				self.__history_vector[0] = self.__state_vector[0]
				transitioned_after = 0
		return transitioned_after
	
	
	def __main_region_traffic_light_r1_interrupted__region0_yellow_react(self, transitioned_before):
		"""Implementation of __main_region_traffic_light_r1_interrupted__region0_yellow_react function.
		"""
		transitioned_after = transitioned_before
		if transitioned_after < 0:
			if self.__time_events[0]:
				self.__exit_sequence_main_region_traffic_light_r1_interrupted__region0_yellow()
				self.__time_events[0] = False
				self.__enter_sequence_main_region_traffic_light_r1_interrupted__region0_black_default()
				self.__main_region_traffic_light_r1_interrupted_react(0)
				transitioned_after = 0
		#If no transition was taken then execute local reactions
		if transitioned_after == transitioned_before:
			transitioned_after = self.__main_region_traffic_light_r1_interrupted_react(transitioned_before)
		return transitioned_after
	
	
	def __main_region_traffic_light_r1_interrupted__region0_black_react(self, transitioned_before):
		"""Implementation of __main_region_traffic_light_r1_interrupted__region0_black_react function.
		"""
		transitioned_after = transitioned_before
		if transitioned_after < 0:
			if self.__time_events[1]:
				self.__exit_sequence_main_region_traffic_light_r1_interrupted__region0_black()
				self.__time_events[1] = False
				self.__enter_sequence_main_region_traffic_light_r1_interrupted__region0_yellow_default()
				self.__main_region_traffic_light_r1_interrupted_react(0)
				transitioned_after = 0
		#If no transition was taken then execute local reactions
		if transitioned_after == transitioned_before:
			transitioned_after = self.__main_region_traffic_light_r1_interrupted_react(transitioned_before)
		return transitioned_after
	
	
	def __main_region_traffic_light_r1_normal_operation_react(self, transitioned_before):
		"""Implementation of __main_region_traffic_light_r1_normal_operation_react function.
		"""
		transitioned_after = transitioned_before
		if transitioned_after < 0:
			if self.interrupt:
				self.__exit_sequence_main_region_traffic_light_r1_normal_operation()
				self.__enter_sequence_main_region_traffic_light_r1_interrupted_default()
				transitioned_after = 0
		return transitioned_after
	
	
	def __main_region_traffic_light_r1_normal_operation__region0_green_react(self, transitioned_before):
		"""Implementation of __main_region_traffic_light_r1_normal_operation__region0_green_react function.
		"""
		transitioned_after = transitioned_before
		if transitioned_after < 0:
			if self.__time_events[2]:
				self.__exit_sequence_main_region_traffic_light_r1_normal_operation__region0_green()
				self.__time_events[2] = False
				self.__enter_sequence_main_region_traffic_light_r1_normal_operation__region0_yellow_default()
				self.__main_region_traffic_light_r1_normal_operation_react(0)
				transitioned_after = 0
		#If no transition was taken then execute local reactions
		if transitioned_after == transitioned_before:
			transitioned_after = self.__main_region_traffic_light_r1_normal_operation_react(transitioned_before)
		return transitioned_after
	
	
	def __main_region_traffic_light_r1_normal_operation__region0_yellow_react(self, transitioned_before):
		"""Implementation of __main_region_traffic_light_r1_normal_operation__region0_yellow_react function.
		"""
		transitioned_after = transitioned_before
		if transitioned_after < 0:
			if self.__time_events[3]:
				self.__exit_sequence_main_region_traffic_light_r1_normal_operation__region0_yellow()
				self.__time_events[3] = False
				self.__enter_sequence_main_region_traffic_light_r1_normal_operation__region0_red_default()
				self.__main_region_traffic_light_r1_normal_operation_react(0)
				transitioned_after = 0
		#If no transition was taken then execute local reactions
		if transitioned_after == transitioned_before:
			transitioned_after = self.__main_region_traffic_light_r1_normal_operation_react(transitioned_before)
		return transitioned_after
	
	
	def __main_region_traffic_light_r1_normal_operation__region0_red_react(self, transitioned_before):
		"""Implementation of __main_region_traffic_light_r1_normal_operation__region0_red_react function.
		"""
		transitioned_after = transitioned_before
		if transitioned_after < 0:
			if self.__time_events[4]:
				self.__exit_sequence_main_region_traffic_light_r1_normal_operation__region0_red()
				self.__time_events[4] = False
				self.__enter_sequence_main_region_traffic_light_r1_normal_operation__region0_green_default()
				self.__main_region_traffic_light_r1_normal_operation_react(0)
				transitioned_after = 0
		#If no transition was taken then execute local reactions
		if transitioned_after == transitioned_before:
			transitioned_after = self.__main_region_traffic_light_r1_normal_operation_react(transitioned_before)
		return transitioned_after
	
	
	def __main_region_traffic_light_r2_timer_react(self, transitioned_before):
		"""Implementation of __main_region_traffic_light_r2_timer_react function.
		"""
		transitioned_after = transitioned_before
		#If no transition was taken then execute local reactions
		if transitioned_after == transitioned_before:
			transitioned_after = self.__main_region_traffic_light_react(transitioned_before)
		return transitioned_after
	
	
	def __main_region_traffic_light_r2_timer__region0_off_react(self, transitioned_before):
		"""Implementation of __main_region_traffic_light_r2_timer__region0_off_react function.
		"""
		transitioned_after = transitioned_before
		if transitioned_after < 1:
			if self.timer_on:
				self.__exit_sequence_main_region_traffic_light_r2_timer__region0_off()
				self.__enter_sequence_main_region_traffic_light_r2_timer__region0_on_default()
				self.__main_region_traffic_light_r2_timer_react(1)
				transitioned_after = 1
		#If no transition was taken then execute local reactions
		if transitioned_after == transitioned_before:
			transitioned_after = self.__main_region_traffic_light_r2_timer_react(transitioned_before)
		return transitioned_after
	
	
	def __main_region_traffic_light_r2_timer__region0_on_react(self, transitioned_before):
		"""Implementation of __main_region_traffic_light_r2_timer__region0_on_react function.
		"""
		transitioned_after = transitioned_before
		if transitioned_after < 1:
			if self.__time_events[5]:
				self.__exit_sequence_main_region_traffic_light_r2_timer__region0_on()
				self.__remaining_time = self.__remaining_time - 1
				self.__time_events[5] = False
				self.__enter_sequence_main_region_traffic_light_r2_timer__region0_on_default()
				self.__main_region_traffic_light_r2_timer_react(1)
				transitioned_after = 1
			elif self.timer_off:
				self.__exit_sequence_main_region_traffic_light_r2_timer__region0_on()
				self.__enter_sequence_main_region_traffic_light_r2_timer__region0_off_default()
				self.__main_region_traffic_light_r2_timer_react(1)
				transitioned_after = 1
			elif self.timer_on:
				self.__exit_sequence_main_region_traffic_light_r2_timer__region0_on()
				self.__enter_sequence_main_region_traffic_light_r2_timer__region0_on_default()
				self.__main_region_traffic_light_r2_timer_react(1)
				transitioned_after = 1
		#If no transition was taken then execute local reactions
		if transitioned_after == transitioned_before:
			transitioned_after = self.__main_region_traffic_light_r2_timer_react(transitioned_before)
		return transitioned_after
	
	
	def __main_region_off_react(self, transitioned_before):
		"""Implementation of __main_region_off_react function.
		"""
		transitioned_after = transitioned_before
		if transitioned_after < 0:
			if self.toggle_on_off:
				self.__exit_sequence_main_region_off()
				self.__react_main_region_traffic_light_r1_h()
				self.__enter_sequence_main_region_traffic_light_r2_default()
				self.__react(0)
				transitioned_after = 0
		#If no transition was taken then execute local reactions
		if transitioned_after == transitioned_before:
			transitioned_after = self.__react(transitioned_before)
		return transitioned_after
	
	
	def __clear_in_events(self):
		"""Implementation of __clear_in_events function.
		"""
		self.interrupt = False
		self.toggle_on_off = False
		self.__time_events[0] = False
		self.__time_events[1] = False
		self.__time_events[2] = False
		self.__time_events[3] = False
		self.__time_events[4] = False
		self.__time_events[5] = False
	
	
	def __clear_internal_events(self):
		"""Implementation of __clear_internal_events function.
		"""
		self.timer_on = False
		self.timer_off = False
	
	
	def __micro_step(self):
		"""Implementation of __micro_step function.
		"""
		transitioned = -1
		self.__state_conf_vector_position = 0
		state = self.__state_vector[0]
		if state == self.State.main_region_traffic_light_r1interrupted_region0yellow:
			transitioned = self.__main_region_traffic_light_r1_interrupted__region0_yellow_react(transitioned)
		elif state == self.State.main_region_traffic_light_r1interrupted_region0black:
			transitioned = self.__main_region_traffic_light_r1_interrupted__region0_black_react(transitioned)
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0green:
			transitioned = self.__main_region_traffic_light_r1_normal_operation__region0_green_react(transitioned)
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0yellow:
			transitioned = self.__main_region_traffic_light_r1_normal_operation__region0_yellow_react(transitioned)
		elif state == self.State.main_region_traffic_light_r1normal_operation_region0red:
			transitioned = self.__main_region_traffic_light_r1_normal_operation__region0_red_react(transitioned)
		elif state == self.State.main_region_off:
			transitioned = self.__main_region_off_react(transitioned)
		if self.__state_conf_vector_position < 1:
			state = self.__state_vector[1]
			if state == self.State.main_region_traffic_light_r2timer_region0off:
				transitioned = self.__main_region_traffic_light_r2_timer__region0_off_react(transitioned)
			elif state == self.State.main_region_traffic_light_r2timer_region0on:
				transitioned = self.__main_region_traffic_light_r2_timer__region0_on_react(transitioned)
	
	
	def run_cycle(self):
		"""Implementation of run_cycle function.
		"""
		if self.timer_service is None:
			raise ValueError('Timer service must be set.')
		
		if self.__is_executing:
			return
		self.__is_executing = True
		next_event = self.__get_next_event()
		if next_event is not None:
			self.__execute_queued_event(next_event)
		condition_0 = True
		while condition_0:
			self.__micro_step()
			self.__clear_in_events()
			self.__clear_internal_events()
			next_event = self.__get_next_event()
			if next_event is not None:
				self.__execute_queued_event(next_event)
			condition_0 = self.interrupt or self.toggle_on_off or self.timer_on or self.timer_off or self.__time_events[0] or self.__time_events[1] or self.__time_events[2] or self.__time_events[3] or self.__time_events[4] or self.__time_events[5]
		self.__is_executing = False
	
	
	def enter(self):
		"""Implementation of enter function.
		"""
		if self.timer_service is None:
			raise ValueError('Timer service must be set.')
		
		if self.__is_executing:
			return
		self.__is_executing = True
		self.__enter_sequence_main_region_default()
		self.__is_executing = False
	
	
	def exit(self):
		"""Implementation of exit function.
		"""
		if self.__is_executing:
			return
		self.__is_executing = True
		self.__exit_sequence_main_region()
		self.__is_executing = False
	
	
	
